<template>
  <el-card class="mod-schedule">
    <el-form :inline="true" :model="dataForm" @keyup.enter.native="handleGetTableList()">
      <el-form-item>
        <el-input v-model="dataForm.beanName" placeholder="bean名称" clearable></el-input>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleGetTableList()">查询</el-button>
        <el-button v-if="isAuth('sys:schedule:save')" type="primary" @click="handleAddOrUpdate()">新增</el-button>
        <el-button
          v-if="isAuth('sys:schedule:delete')"
          type="danger"
          @click="handleDelete()"
          :disabled="dataListSelections.length <= 0"
        >批量删除</el-button>
        <el-button
          v-if="isAuth('sys:schedule:pause')"
          type="danger"
          @click="handlePause()"
          :disabled="dataListSelections.length <= 0"
        >批量暂停</el-button>
        <el-button
          v-if="isAuth('sys:schedule:resume')"
          type="danger"
          @click="handleResume()"
          :disabled="dataListSelections.length <= 0"
        >批量恢复</el-button>
        <el-button
          v-if="isAuth('sys:schedule:run')"
          type="danger"
          @click="handleRun()"
          :disabled="dataListSelections.length <= 0"
        >批量立即执行</el-button>
        <el-button v-if="isAuth('sys:schedule:log')" type="success" @click="handleLog()">日志列表</el-button>
      </el-form-item>
    </el-form>
    <el-table
      :data="dataList"
      border
      v-loading="dataListLoading"
      @selection-change="handleChangeSelection"
      style="width: 100%;"
    >
      <el-table-column type="selection" header-align="center" align="center" width="50"></el-table-column>
      <el-table-column prop="jobId" header-align="center" align="center" width="80" label="ID"></el-table-column>
      <el-table-column prop="beanName" header-align="center" align="center" label="bean名称"></el-table-column>
      <el-table-column prop="params" header-align="center" align="center" label="参数"></el-table-column>
      <el-table-column prop="cronExpression" header-align="center" align="center" label="cron表达式"></el-table-column>
      <el-table-column prop="remark" header-align="center" align="center" label="备注"></el-table-column>
      <el-table-column prop="status" header-align="center" align="center" label="状态">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.status === 0" size="small">正常</el-tag>
          <el-tag v-else size="small" type="danger">暂停</el-tag>
        </template>
      </el-table-column>
      <el-table-column fixed="right" header-align="center" align="center" width="150" label="操作">
        <template slot-scope="scope">
          <el-button
            v-if="isAuth('sys:schedule:update')"
            type="text"
            size="small"
            @click="handleAddOrUpdate(scope.row.jobId)"
          >编辑</el-button>
          <el-button
            v-if="isAuth('sys:schedule:delete')"
            type="text"
            size="small"
            @click="handleDelete(scope.row.jobId)"
          >删除</el-button>
          <el-button
            v-if="isAuth('sys:schedule:pause')"
            type="text"
            size="small"
            @click="handlePause(scope.row.jobId)"
          >暂停</el-button>
          <el-button
            v-if="isAuth('sys:schedule:resume')"
            type="text"
            size="small"
            @click="handleResume(scope.row.jobId)"
          >恢复</el-button>
          <el-button
            v-if="isAuth('sys:schedule:run')"
            type="text"
            size="small"
            @click="handleRun(scope.row.jobId)"
          >立即执行</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      @size-change="handleChangeSize"
      @current-change="handleChangeCurrent"
      :current-page="pageIndex"
      :page-sizes="[10, 20, 50, 100]"
      :page-size="pageSize"
      :total="totalPage"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <!-- 弹窗, 新增 / 编辑 -->
    <add-or-update
      v-if="addOrUpdateVisible"
      ref="addOrUpdate"
      @refreshDataList="handleGetTableList"
    ></add-or-update>
    <!-- 弹窗, 日志列表 -->
    <log v-if="logVisible" ref="log"></log>
  </el-card>
</template>

<script>
import AddOrUpdate from './schedule-add-or-update'
import Log from './schedule-log'
import { apiSysScheduleList, apiSysScheduleDelete, apiSysSchedulePause, apiSysScheduleResume, apiSysScheduleRun } from '@/api/api_sys'

export default {
  data () {
    return {
      dataForm: {
        beanName: ''
      },
      dataList: [],
      pageIndex: 1,
      pageSize: 20,
      totalPage: 0,
      dataListLoading: false,
      dataListSelections: [],
      addOrUpdateVisible: false,
      logVisible: false
    }
  },
  components: {
    AddOrUpdate,
    Log
  },
  activated () {
    this.handleGetTableList()
  },
  methods: {
    // 获取数据列表
    handleGetTableList () {
      apiSysScheduleList({
        'page': this.pageIndex,
        'limit': this.pageSize,
        'beanName': this.dataForm.beanName
      }).then(res => {
        if (res && res.code === 0) {
          this.dataList = res.page.list
          this.totalPage = res.page.totalCount
        } else {
          this.dataList = []
          this.totalPage = 0
        }
        this.dataListLoading = false
      })
    },
    // 每页数
    handleChangeSize (val) {
      this.pageSize = val
      this.pageIndex = 1
      this.handleGetTableList()
    },
    // 当前页
    handleChangeCurrent (val) {
      this.pageIndex = val
      this.handleGetTableList()
    },
    // 多选
    handleChangeSelection (val) {
      this.dataListSelections = val
    },
    // 新增 / 编辑
    handleAddOrUpdate (id) {
      this.addOrUpdateVisible = true
      this.$nextTick(() => {
        this.$refs.addOrUpdate.init(id)
      })
    },
    // 删除
    handleDelete (id) {
      let ids = id ? [id] : this.dataListSelections.map(item => {
        return item.jobId
      })
      this.$confirm(`确定对[id=${ids.join(',')}]进行[${id ? '删除' : '批量删除'}]操作?`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        apiSysScheduleDelete(ids).then(res => {
          if (res && res.code === 0) {
            this.$message({
              message: '操作成功',
              type: 'success',
              duration: 1500,
              onClose: () => {
                this.handleGetTableList()
              }
            })
          } else {
            this.$message.error(res.msg)
          }
        })
      }).catch(() => { })
    },
    // 暂停
    handlePause (id) {
      let ids = id ? [id] : this.dataListSelections.map(item => {
        return item.jobId
      })
      this.$confirm(`确定对[id=${ids.join(',')}]进行[${id ? '暂停' : '批量暂停'}]操作?`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        apiSysSchedulePause(ids).then(res => {
          if (res && res.code === 0) {
            this.$message({
              message: '操作成功',
              type: 'success',
              duration: 1500,
              onClose: () => {
                this.handleGetTableList()
              }
            })
          } else {
            this.$message.error(res.msg)
          }
        })
      }).catch(() => { })
    },
    // 恢复
    handleResume (id) {
      let ids = id ? [id] : this.dataListSelections.map(item => {
        return item.jobId
      })
      this.$confirm(`确定对[id=${ids.join(',')}]进行[${id ? '恢复' : '批量恢复'}]操作?`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        apiSysScheduleResume(ids).then(res => {
          if (res && res.code === 0) {
            this.$message({
              message: '操作成功',
              type: 'success',
              duration: 1500,
              onClose: () => {
                this.handleGetTableList()
              }
            })
          } else {
            this.$message.error(res.msg)
          }
        })
      }).catch(() => { })
    },
    // 立即执行
    handleRun (id) {
      var ids = id ? [id] : this.dataListSelections.map(item => {
        return item.jobId
      })
      this.$confirm(`确定对[id=${ids.join(',')}]进行[${id ? '立即执行' : '批量立即执行'}]操作?`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        apiSysScheduleRun(ids).then(res => {
          if (res && res.code === 0) {
            this.$message({
              message: '操作成功',
              type: 'success',
              duration: 1500,
              onClose: () => {
                this.handleGetTableList()
              }
            })
          } else {
            this.$message.error(res.msg)
          }
        })
      }).catch(() => { })
    },
    // 日志列表
    handleLog () {
      this.logVisible = true
      this.$nextTick(() => {
        this.$refs.log.init()
      })
    }
  }
}
</script>
